Skip to main content

dhtmlxGantt with Vue.js

note

This tutorial shows how to use the JS DHTMLX Gantt package directly in a Vue app without the official wrapper.

If you want Vue props/events, wrapper-managed sync, and wrapper composables, use Vue Gantt instead.

This page is for low-level integration. You initialize and manage the Gantt instance yourself.

Prerequisites​

  • Node.js installed
  • Basic Vue 3 knowledge (components, refs, lifecycle hooks)
  • A Vue 3 project (this tutorial shows how to create one with Vite)

1. Create A Vue Project​

Create a Vue 3 app with Vite:

npm create vue@latest gantt-vue-app
cd gantt-vue-app

Install dependencies and start the dev server once to confirm the project works:

  • npm:
npm install
npm run dev
  • yarn:
yarn install
yarn dev

The app should be available at http://localhost:5173.

Gantt Vue app running

Stop the dev server (Ctrl+C) before the next step.

2. Install The JS Gantt Package​

Professional builds of the JS Gantt library are available via private npm. Follow the installation guide to get access.

Evaluation build (public tutorial package):

  • npm:
npm install @dhx/trial-gantt
  • yarn:
yarn add @dhx/trial-gantt

Professional build (private npm):

  • npm:
npm install @dhx/gantt
  • yarn:
yarn add @dhx/gantt

You can also install Gantt from a local folder because the package is structured as an npm module.

3. Create A Gantt Component​

Create src/components/GanttView.vue and initialize Gantt in Vue lifecycle hooks.

If you installed the evaluation build, use these imports:

src/components/GanttView.vue
<script setup lang="ts">
import { onBeforeUnmount, onMounted, ref } from "vue";
import { Gantt, type GanttStatic } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

const container = ref<HTMLElement | null>(null);
let gantt: GanttStatic | null = null;

onMounted(() => {
if (!container.value) return;

gantt = Gantt.getGanttInstance();
gantt.init(container.value);
});

onBeforeUnmount(() => {
gantt?.destructor();
gantt = null;
});
</script>

<template>
<div ref="container" className="gantt-host"></div>
</template>

<style>
.gantt-host {
width: 100%;
height: 600px;
}
</style>

If you installed the professional build, replace the package imports:

import { Gantt, type GanttStatic } from "@dhx/gantt";
import "@dhx/gantt/codebase/dhtmlxgantt.css";

If you installed Gantt from a local folder package, imports usually look like this:

import { Gantt, type GanttStatic } from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";

4. Render The Gantt Component In The App​

Replace src/App.vue:

src/App.vue
<script setup lang="ts">
import GanttView from "./components/GanttView.vue";
</script>

<template>
<GanttView />
</template>

To let the chart use the page height, update your global styles (for example src/assets/main.css):

src/assets/main.css
html,
body,
#app {
width: 100%;
height: 100vh;
margin: 0;
padding: 0;
}

Start the app again. You should see an empty Gantt chart.

5. Provide Data​

Create src/demo-data.ts:

src/demo-data.ts
export function getData() {
return {
data: [
{
id: 10,
text: "Project #1",
start_date: "2026-02-02 00:00",
duration: 6,
progress: 0.4,
open: true
},
{
id: 1,
text: "Task #1",
start_date: "2026-02-02 00:00",
duration: 2,
progress: 0.6,
parent: 10
},
{
id: 2,
text: "Task #2",
start_date: "2026-02-04 00:00",
duration: 3,
progress: 0.2,
parent: 10
}
],
links: [{ id: 1, source: 1, target: 2, type: "0" }]
};
}

Update src/components/GanttView.vue and parse the data:

src/components/GanttView.vue
<script setup lang="ts">
import { onBeforeUnmount, onMounted, ref } from "vue";
import { Gantt, type GanttStatic } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
import { getData } from "../demo-data";

const container = ref<HTMLElement | null>(null);
let gantt: GanttStatic | null = null;

onMounted(() => {
if (!container.value) return;

gantt = Gantt.getGanttInstance();
gantt.config.date_format = "%Y-%m-%d %H:%i";
gantt.init(container.value);
gantt.parse(getData());
});

onBeforeUnmount(() => {
gantt?.destructor();
gantt = null;
});
</script>

<template>
<div ref="container" className="gantt-host"></div>
</template>

<style>
.gantt-host {
width: 100%;
height: 600px;
}
</style>

Reload the page. You should see a Gantt chart with tasks and a dependency link.

6. Capture And Save Changes​

Use a dataProcessor to handle chart changes and send them to your backend.

Add a handler after gantt.init(...):

gantt.createDataProcessor((entity, action, data, id) => {
console.log("[dp]", entity, action, data, id);
});

DHTMLX Gantt accepts Promise responses from dataProcessor handlers. If your backend changes IDs on create, return an object like { id: newId } or { tid: newId } so Gantt can remap the record.

For full backend patterns, see server-side integration.

Result​

You now have a Vue app with direct JS Gantt integration:

  • Vue owns the component lifecycle
  • your code initializes and destroys the Gantt instance
  • data is loaded with gantt.parse(...)
  • edits can be handled with gantt.createDataProcessor(...)

Security Note​

Gantt does not protect your backend from SQL injection, XSS, or CSRF. Backend validation, authorization, and output sanitization remain your responsibility.

Read Application Security for the main risk areas and mitigation guidance.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Skip to main content

dhtmlxGantt with Angular

note

This tutorial shows how to use the JS DHTMLX Gantt directly in an Angular app without the official wrapper.

If you want Angular inputs/outputs, wrapper-managed sync, and Angular template component support, use Angular Gantt instead.

You should be familiar with basic Angular concepts (components, lifecycle hooks, services). If not, start with the Angular documentation.

DHTMLX Gantt is compatible with Angular. You can check the related demo repository on GitHub: DHTMLX Gantt with Angular Demo.

Creating A Project​

Before you start, install Node.js and Angular CLI.

Create a new Angular app:

ng new my-angular-gantt-app --standalone --routing=false --style=css
cd my-angular-gantt-app

Start the app once to verify the project is working:

  • npm: npm start
  • yarn: yarn start
  • or CLI: ng serve

The app should be available at http://localhost:4200.

Creating Gantt​

Stop the dev server (Ctrl+C) before installing the Gantt package.

Step 1. Package Installation​

Professional builds of the JS Gantt library are available via private npm. Follow the installation guide to get access.

Evaluation build (public package for tutorials):

  • npm:
npm install @dhx/trial-gantt
  • yarn:
yarn add @dhx/trial-gantt

Professional build (private npm):

  • npm:
npm install @dhx/gantt
  • yarn:
yarn add @dhx/gantt

You can also install Gantt from a local folder because the package is structured as an npm module.

Step 2. Create A Gantt Component​

Create a new component for direct JS Gantt integration:

ng generate component gantt --skip-tests

Import Gantt Source Files​

Open src/app/gantt/gantt.component.ts and import the Gantt package.

If you installed the evaluation build:

src/app/gantt/gantt.component.ts
import { Gantt, type GanttStatic } from '@dhx/trial-gantt';

If you installed the professional build:

src/app/gantt/gantt.component.ts
import { Gantt, type GanttStatic } from '@dhx/gantt';

Add Gantt styles in src/app/gantt/gantt.component.css.

Evaluation build:

src/app/gantt/gantt.component.css
@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

Professional build:

src/app/gantt/gantt.component.css
@import "@dhx/gantt/dist/dhtmlxgantt.css";

Initialize Gantt In Angular Lifecycle Hooks​

Replace src/app/gantt/gantt.component.ts with a minimal direct integration:

src/app/gantt/gantt.component.ts
import { AfterViewInit, Component, ElementRef, OnDestroy, ViewChild, ViewEncapsulation } from '@angular/core';
import { Gantt, type GanttStatic } from '@dhx/trial-gantt';

@Component({
selector: 'app-gantt',
standalone: true,
template: `<div #ganttHost className="gantt-chart"></div>`,
styleUrl: './gantt.component.css',
encapsulation: ViewEncapsulation.None,
})
export class GanttComponent implements AfterViewInit, OnDestroy {
@ViewChild('ganttHost', { static: true }) ganttHost!: ElementRef<HTMLElement>;

private gantt: GanttStatic | null = null;

ngAfterViewInit(): void {
const gantt = Gantt.getGanttInstance();
gantt.init(this.ganttHost.nativeElement);
this.gantt = gantt;
}

ngOnDestroy(): void {
this.gantt?.destructor();
this.gantt = null;
}
}

Add basic container sizing to src/app/gantt/gantt.component.css:

src/app/gantt/gantt.component.css
@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

.gantt-chart {
width: 100%;
height: 600px;
}

Step 3. Add Gantt To The App​

Replace src/app/app.component.ts so the app renders your Gantt component:

src/app/app.component.ts
import { Component } from '@angular/core';
import { GanttComponent } from './gantt/gantt.component';

@Component({
selector: 'app-root',
standalone: true,
imports: [GanttComponent],
template: `<app-gantt></app-gantt>`,
})
export class AppComponent {}

After starting the app, you should see an empty Gantt chart.

Step 4. Provide Data​

Create src/app/demo-data.ts with a small dataset:

src/app/demo-data.ts
export function getData() {
return {
data: [
{
id: 10,
text: 'Project #1',
start_date: '2026-02-02 00:00',
duration: 6,
progress: 0.4,
open: true,
},
{
id: 1,
text: 'Task #1',
start_date: '2026-02-02 00:00',
duration: 2,
progress: 0.6,
parent: 10,
},
{
id: 2,
text: 'Task #2',
start_date: '2026-02-04 00:00',
duration: 3,
progress: 0.2,
parent: 10,
},
],
links: [{ id: 1, source: 1, target: 2, type: '0' }],
};
}

Now import and parse the data in GanttComponent:

src/app/gantt/gantt.component.ts
import { getData } from '../demo-data';

// ...inside ngAfterViewInit()
const gantt = Gantt.getGanttInstance();
gantt.config.date_format = '%Y-%m-%d %H:%i';
gantt.init(this.ganttHost.nativeElement);
gantt.parse(getData());
this.gantt = gantt;

If you reload the app, you should see a Gantt chart with tasks and a link.

Step 5. Save Data​

To capture changes made in the chart, use a dataProcessor. It can send changes to your backend or just log them while you build the integration.

src/app/gantt/gantt.component.ts
// ...inside ngAfterViewInit(), after gantt.init(...)
gantt.createDataProcessor((entity, action, data, id) => {
console.log('[dp]', entity, action, data, id);
});

DHTMLX Gantt accepts Promise responses from dataProcessor handlers. If your backend changes IDs on create, return an object like { id: newId } or { tid: newId } so Gantt can remap the record.

See server-side integration for full backend patterns.

XSS, CSRF And SQL Injection Attacks​

Gantt does not protect your application from backend security issues (SQL injection, XSS, CSRF). Backend validation, authorization, and output sanitization remain your responsibility.

Read Application Security for the main risk areas and mitigation guidance.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Skip to main content

dhtmlxGantt with React

note

This tutorial covers the usage of the JS DHTMLX Gantt in React apps. If you want to use the official React Gantt component, please refer to React Gantt article.

You should be familiar with the basic concepts and patterns of React to use this documentation. If you are not, please refer to the React documentation for a getting-started tutorial.

DHTMLX Gantt is compatible with React. You can check the corresponding example on GitHub: DHTMLX Gantt with React Demo.

Creating a project​

Before you start to create a new project, install Node.js.

You can create a basic React project using the following command:

npx create-vite my-react-gantt-app --template react

Installation of dependencies​

Next you should go to the app directory. Let's call our project my-react-gantt-app and run:

cd my-react-gantt-app

After that you should install dependencies and start the dev server. For this, you need to make use of a package manager:

  • if you use yarn, you need to call the following commands:
yarn install
yarn dev
  • if you use npm, you need to call the following commands:
npm install
npm run dev

You should now have your React project running on http://localhost:5173.

Gantt React app running

Creating Gantt​

Now we should get the DHTMLX Gantt code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Gantt package.

Step 1. Package installation​

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Gantt, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-gantt
  • for yarn:
yarn add @dhx/trial-gantt

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation​

Now we should create a React component, to add a Gantt into the application. Let's create the Gantt.jsx file in the src/ directory.

Importing source files​

Open the newly created Gantt.jsx file and import Gantt source files. Note that:

  • if you've installed the Gantt package from a local folder, your import paths will look like this:
Gantt.jsx
import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • if you've chosen to install the trial version, the import paths should be as in:
Gantt.jsx
import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

In this tutorial, we will use the trial version of Gantt.

Setting the container and adding Gantt​

To display Gantt on the page, we need to set the container to render the component inside. The Gantt.jsx file should contain the following code:

Gantt.jsx
import { useEffect, useRef } from "react"; /*!*/
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

export default function GanttView() { /*!*/
let container = useRef(); /*!*/

useEffect(() => { /*!*/
let gantt = Gantt.getGanttInstance(); /*!*/
gantt.init(container.current); /*!*/

return () => { /*!*/
gantt.destructor(); /*!*/
container.current.innerHTML = ""; /*!*/
}; /*!*/
}, []); /*!*/

return <div ref="{container}" style={{}} {width: "100%", height: "100%"} }></div>; /*!*/
} /*!*/

Step 3. Adding Gantt into the app​

Now it's time to add the component into our app. Open src/app.jsx and use the Gantt component instead of the default content by inserting the code below:

src/app.jsx
import Gantt from "./Gantt";

function App() {
return <Gantt/>;
}

export default App;

To make the Gantt container occupy the entire space of the body, you need to remove the default styles from the index.css file located in the src/ folder and add the following one:

src/index.css
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

After that, when we start the app, we should see an empty Gantt on a page:

Gantt React init

Step 4. Providing Data​

To add data into the Gantt, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js
export function getData() {
const tasks = {
data: [
{
id: "10",
text: "Project #1",
start_date: "01-04-2025",
duration: 3,
order: 10,
progress: 0.4,
open: true,
},
{
id: "1",
text: "Task #1",
start_date: "01-04-2025",
duration: 1,
order: 10,
progress: 0.6,
parent: "10",
},
{
id: "2",
text: "Task #2",
start_date: "02-04-2025",
duration: 2,
order: 20,
progress: 0.6,
parent: "10",
},
],
links: [{ id: 1, source: 1, target: 2, type: "0" }],
};
return tasks;
}

We should pass props (our data) to a Gantt component in App.jsx:

Gantt.jsx
import Gantt from "./Gantt";
import { getData } from "./data.js";

function App() {
return <Gantt tasks="{getData()}" />;
}

export default App;

And use the props in the gantt.parse() method in the Gantt component:

Gantt.jsx
import { useEffect, useRef } from "react";
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

export default function GanttView(props) {
let container = useRef();

useEffect(() => {
let gantt = Gantt.getGanttInstance();
gantt.init(container.current);
gantt.parse(props.tasks); /*!*/

return () => {
gantt.destructor();
container.current.innerHTML = "";
};
}, []);

return <div ref="{container}" style={{}} {width: "100%", height: "100%"} }></div>;
}

Now, if you reopen the app page, you should see a Gantt with tasks:

Gantt tasks

Step 5. Saving Data​

To capture changes made in the Gantt, you can use a dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxGantt accepts a Promise response from the handler, so your Gantt will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

gantt.createDataProcessor(function(entity, action, data, id) {​
gantt.message(`${​entity} ${​action}`);
});

If your service changes the task id after creating a new record (which it usually does), make sure that your Promise returns an object with (id: databaseId) or (tid: databaseId) as a result, so that Gantt could apply the new database id to the record. Get more information about the server side.

Well, React Gantt is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks​

Pay attention that Gantt doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.